#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <sdktools_entinput>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Hostage Rescue]",
	author	= "wS",
	version = "1.0.1"
};

#define ITEM_NAME  "hostage_rescue"
#define ZONE_MODEL "models/props/cs_office/vending_machine.mdl"

new bool:g_bAccess[MAXPLAYERS + 1];
new bool:g_bNeedGiveDefuser;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);

	HookEvent("hostage_follows", hostage_follows, EventHookMode_Post);
	if (GetEngineVersion() == Engine_CSGO) VIP_HookEvent(VE_Spawn, VIP_OnClientSpawn);
}

public OnConfigsExecuted()
{
	PrecacheModel(ZONE_MODEL);
	g_bNeedGiveDefuser = (GetEngineVersion() == Engine_CSGO && FindEntityByClassname(-1, "hostage_entity") > MaxClients);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	if (g_bNeedGiveDefuser && IsPlayerAlive(client)) SetEntProp(client, Prop_Send, "m_bHasDefuser", true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient) SetStatus(client, false);
public OnClientDisconnect(client) g_bAccess[client] = false;

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public VIP_OnClientSpawn(client, team)
{
	if (g_bAccess[client] && g_bNeedGiveDefuser)
		SetEntProp(client, Prop_Send, "m_bHasDefuser", true);
}

public hostage_follows(Handle:event, const String:name[], bool:silent)
{
	if (!g_bAccess[GetClientOfUserId(GetEventInt(event, "userid"))])
		return;

	new hostage = GetEventInt(event, "hostage");
	if (hostage <= MaxClients || !IsValidEntity(hostage))
		return;

	new zone = CreateEntityByName("func_hostage_rescue");
	if (zone <= MaxClients)
		return;

	decl Float:v[3];
	GetEntPropVector(hostage, Prop_Data, "m_vecAbsOrigin", v);
	DispatchKeyValueVector(zone, "origin", v);
	DispatchKeyValue(zone, "OnUser1", "!self,Kill,,0.3,-1");
	DispatchSpawn(zone);
	ActivateEntity(zone);
	SetEntityModel(zone, ZONE_MODEL);
	SetEntPropVector(zone, Prop_Send, "m_vecMins", Float:{-100.0, -100.0, -50.0});
	SetEntPropVector(zone, Prop_Send, "m_vecMaxs", Float:{100.0, 100.0, 210.0});
	SetEntProp(zone, Prop_Send, "m_nSolidType", 2);
	//SetEntProp(zone, Prop_Send, "m_fEffects", GetEntProp(zone, Prop_Send, "m_fEffects") | 32);
	AcceptEntityInput(zone, "Enable");
	AcceptEntityInput(zone, "FireUser1");

	SetEntityMoveType(hostage, MOVETYPE_FLY);
	TeleportEntity(hostage, NULL_VECTOR, NULL_VECTOR, Float:{90.0, 0.0, 1000.0});
}